----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    10:39:31 06/23/2008 
-- Design Name: 
-- Module Name:    counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity counter is
    Port ( CLK : in  STD_LOGIC;
           RST : in  STD_LOGIC;
           LED : out STD_LOGIC_VECTOR (7 downto 0);
			  SG  : out std_logic_vector(7 downto 0);
			  SA  : out std_logic_vector(3 downto 0));
end counter;

architecture Behavioral of counter is
	signal Q: std_logic_vector(3 downto 0);
	signal CLK1S: std_logic;
	signal SGb: std_logic_vector(7 downto 0);
	component div1s
		port (
			CLK: in std_logic;
			CLK1S: out std_logic;
			RST: in std_logic
		);
	end component;
	component dec7seg
		port (
			D: in std_logic_vector(3 downto 0);
			SG: out std_logic_vector(7 downto 0);
			SA: out std_logic_vector(3 downto 0)
		);
	end component;
	
begin
	i0: div1s port map(CLK=>CLK, CLK1S=>CLK1S, RST=>RST);
	i1: dec7seg port map(D=>Q, SG=>SGb, SA=>SA);

	process (CLK1S, RST) begin
		if (RST = '0') then
			Q <= "0000";
		elsif (CLK1S'event and CLK1S = '1') then
			if (Q = 9) then
				Q <= "0000";
			else
				Q <= Q + 1;
			end if;
		end if;
	end process;
	SG <= not SGb;
	LED <= "1111" & not Q;
end Behavioral;

